(require-extension http-server)

; e.g. /person/edit/123
(http:register-route '(controller action id) '())

; e.g /person/new
(http:register-route '(controller action) '())

; e.g. /people
(http:register-route '("people") '((controller . person) (action . list)))

(http:register-controller
 'person
 (lambda (params req)
   (http:write-response-header)
   (let* ((action-param (assq 'action params))
	  (action (if (pair? action-param)
		      (cdr action-param)
		      #f))
	  (msg
	   (string-append
	    (cond ((eq? action  'list)
		   "Let's list all people.")
		  ((eq? action 'new)
		   "Let's send a form to make a person.")
		  ((eq? action 'edit)
		   "Let's send a form to edit a person.")
		  ((eq? action 'update)
		   "Let's apply the user's changes.")
		  (else
		   "We don't know what to do."))
	    " Preferred path: "
	    (http:link-to params))))
     (print
      "Content-type: text/plain\r\nContent-length: "
      (add1 (string-length msg))
      "\r\n\r\n"
      msg))))
((http:make-server 4242) #t)
